package ch.uzh.ifi.ddis.ifp.esper;

/*
 * #%L
 * Esper Statements
 * %%
 * Copyright (C) 2013 University of Zurich, Department of Informatics
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * #L%
 */

/**
 * <p>
 * This bean holds all information which may be provided for an
 * {@link com.espertech.esper.client.EPStatement}.
 * </p>
 * 
 * @author Thomas Scharrenbach
 * @version 0.0.1
 * @since 0.0.1
 * 
 */
public interface EsperStatementBean {

	/**
	 * Statements are enabled by default.
	 */
	static final boolean DEFAULT_ENABLED = true;

	//
	//
	//

	/**
	 * @return if {@link #getName()} is not null, then return {@link #getName()}
	 *         , {@link Object#toString()} otherwise.
	 */
	@Override
	String toString();

	/**
	 * 
	 * @return the hash code of the name if not null, the hashcode of the super
	 *         class, else.
	 */
	@Override
	int hashCode();

	String getName();

	void setName(String name);

	String getEsperStatement();

	void setEsperStatement(String esperStatement);

	boolean isEnabled();

	void setEnabled(boolean enabled);

}
